#include <TFT_eSPI.h>
#include <SPI.h>
TFT_eSPI tft = TFT_eSPI();  // Invoke custom library, pins defined in User_Setup.h

// Assign human-readable names to some common 16-bit color values:
#define  BLACK   0x0000
#define BLUE    0x001F
#define RED     0xF800
#define GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0
#define WHITE   0xFFFF

 int x, y, radius, radius_int, i, j, r2 = radius * 2;
 int w = tft.width();
 int h = tft.height();     
 int sx = w/2;
 int sy = h/2;
 int numPos = 0;
 int depuisPos = 0; 
 int versPos = 0; 
 int oldVersPos = 0;  
 int oldPos = 0; 
 double angle;
struct rectangl  {
   double x1;
   double y1;     
   double x2;
   double y2; 
   double x3;
   double y3;     
   double x4;
   double y4;    
   };
 
struct cart  {
   double x;
   double y; };
 
struct pol   {
   double r;
   double t; };

const double demiPas = 0.0655; 
const double unPas = 0.131;    


boolean trigo = 0;
int horaire = 1;
boolean ordreEnCours = 0;

void pol2cart (struct pol const *pol, struct cart *cart) {
   cart->x = pol->r * cos (pol->t);
   cart->y = pol->r * sin (pol->t);
}
  struct pol polar;
  struct cart cart1;
  struct rectangl lepont;  

void calculePont(rectangl *p_plaque, int Numero){
  double angle ;
  angle = unPas * Numero;
  polar.r = radius_int ;         /* longueur */
  polar.t = demiPas + angle ;                   /* angle en radians */
  pol2cart (&polar, &cart1); // pol2cart (r, t, &x, &y);
  p_plaque->x1 = cart1.x ;
  p_plaque->y1 = cart1.y ;  
  polar.t = - demiPas + angle  ;   
  pol2cart (&polar, &cart1); // pol2cart (r, t, &x, &y);
  p_plaque->x2 = cart1.x ;
  p_plaque->y2 = cart1.y ;  
  polar.r = - radius_int ;      
  pol2cart (&polar, &cart1); // pol2cart (r, t, &x, &y);
  p_plaque->x4 = cart1.x ;
  p_plaque->y4 = cart1.y ;  
  polar.t = demiPas + angle  ;      
  pol2cart (&polar, &cart1); // pol2cart (r, t, &x, &y);
  p_plaque->x3 = cart1.x ;
  p_plaque->y3 = cart1.y ;     
} // FIN CALCULE PONT

void drawPont (rectangl *p_plaque, int Numero){
  tft.drawLine( sx - p_plaque->x2, sy - p_plaque->y2, sx - p_plaque->x1, sy - p_plaque->y1, GREEN);    
  tft.drawLine( sx + p_plaque->x1, sy + p_plaque->y1, sx + p_plaque->x2, sy + p_plaque->y2, GREEN);    
  tft.drawLine(sx - p_plaque->x2, sy - p_plaque->y2, sx + p_plaque->x1, sy + p_plaque->y1, GREEN);    
  tft.drawLine(sx - p_plaque->x1, sy - p_plaque->y1, sx + p_plaque->x2, sy + p_plaque->y2, GREEN);    // TFT_DARKGREEN
  tft.setCursor(20, 285);    
//  tft.setTextSize(1);  tft.setTextColor(YELLOW);  tft.print(Numero);   
  tft.setCursor(20, 285); tft.setTextSize(1);  tft.setTextColor(TFT_YELLOW, TFT_TRANSPARENT); // tft.print("  ");
  tft.printf("%02d", oldVersPos);
  tft.setCursor(80, 285); tft.setTextSize(1);  tft.setTextColor(GREEN, TFT_TRANSPARENT);
  tft.printf("%02d", versPos);
} // FIN DRAWPONT

void refreshPlaque(){  // les n° des ports et le cercle rouge. En double avec drawPlaque
 angle = - 0.01 ; // 0.0655 
 tft.setTextFont(1);
 tft.setTextSize(1);  tft.setTextColor(WHITE, BLACK);
 for (i=0; i<48;  i=i+3 ){
   tft.setCursor(sx -5 + (radius-20) * cos(angle), sy - 2 + (radius-20) * sin(angle)); // 16 ports
   tft.printf("%02d", i); // tft.print(i);      
   angle = angle + 0.131 * 3 ;
 }
 tft.setTextFont(4); 
 tft.drawCircle(w/2, h/2, radius / 2, RED);
}

void erasePont (rectangl *p_plaque, int Numero){
  tft.drawLine( sx - p_plaque->x2, sy - p_plaque->y2, sx - p_plaque->x1, sy - p_plaque->y1, BLACK);    
  tft.drawLine( sx + p_plaque->x1, sy + p_plaque->y1, sx + p_plaque->x2, sy + p_plaque->y2, BLACK);    
  tft.drawLine(sx - p_plaque->x2, sy - p_plaque->y2, sx + p_plaque->x1, sy + p_plaque->y1, BLACK);    
  tft.drawLine(sx - p_plaque->x1, sy - p_plaque->y1, sx + p_plaque->x2, sy + p_plaque->y2, BLACK);    
  tft.setCursor(20, 285); 
  refreshPlaque() ;    
//  tft.setTextSize(1);  tft.setTextColor(BLACK);  tft.print(Numero); 
//  tft.drawCircle(w/2, h/2, radius / 2, RED);    
} // FIN EFFACE PONT

void drawPlaque(){
 radius = (w / 2) -w/20;
 radius_int = radius-radius/10;
 tft.fillCircle(w/2, h/2, radius, WHITE);
 tft.fillCircle(w/2, h/2, radius_int, BLACK);
 tft.drawCircle(w/2, h/2, radius / 2, RED);
 angle = 0.0655 ;  // 0.0655
 for (i=0; i<48;  i++ ){
   tft.drawLine(sx + radius* cos(angle), sy + radius* sin(angle), sx + radius_int * cos(angle), sy + radius_int* sin(angle), BLACK); // 48 secteurs
   angle = angle + 0.131 ;
 }
 angle = - 0.01 ; // 0.0655 
 tft.setTextFont(1);
 tft.setTextSize(1);  tft.setTextColor(WHITE, BLACK);
 for (i=0; i<48;  i=i+3 ){
   tft.setCursor(sx -5 + (radius-20) * cos(angle), sy - 2 + (radius-20) * sin(angle)); // 16 ports
   tft.printf("%02d", i); // tft.print(i);      
   angle = angle + 0.131 * 3 ;
 }
 tft.setTextFont(4);
} // FIN DRAWPLAQUE 

void displayToPosition( int from, int getTo){
 int transit = getTo-from ;
 if ( transit < 0 ) { transit = transit + 49 ;}
 if ( transit < 24 ) { horaire = 1;} else {horaire = - 1; transit = 49 - transit ;} // 1 cas classique en avant
/* affiche le sens dedans la plaque
 if (horaire == 1) {
   tft.setCursor(110, 65); tft.setTextSize(2); tft.setTextColor(BLACK); tft.print("<");  // 60, 285
   tft.setCursor(110, 65); tft.setTextSize(2); tft.setTextColor(GREEN); tft.print(">");  
 }
 if (horaire == -1) {
    tft.setCursor(110, 65); tft.setTextSize(2); tft.setTextColor(BLACK); tft.print(">");
    tft.setCursor(110, 65); tft.setTextSize(2); tft.setTextColor(GREEN); tft.print("<");
 }
*/ 
 for ( i = 1 ; i <= transit ; i++ ){
     numPos = (from  + i * horaire) % 48 ; 
     if ( numPos < 0 ) {from = i + 47; numPos=47; } 
     calculePont(&lepont, oldPos);
     erasePont (&lepont, oldPos);    
     calculePont(&lepont, numPos);
     oldPos = numPos;
     drawPont (&lepont, numPos);
  }
}

/* 
 void getToPosition(int from, int getTo) {     
  if (horaire == 1) {
     Serial.print ("<a 17 1 1>") ; //  TurtableReverseDirection 66
     Serial.print ("<a 17 2 1>") ; //  TurtableSolenoid         67   
  }  
  if (horaire == -1)  {
     Serial.print ("<a 17 1 0>") ;  //  TurtableDirectDirection 
     Serial.print ("<a 17 2 1>") ; //  TurtableSolenoid         67  
  }
  delay (300); 

 ordreEnCours = 0;    
}  // END getToPosition
*/
